import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
export declare const protobufPackage = "drp.node.v1";
export interface SubscribeDRPRequest {
    drpId: string;
}
export interface UnsubscribeDRPRequest {
    drpId: string;
}
export interface GetDRPHashGraphRequest {
    drpId: string;
}
export interface GetDRPHashGraphResponse {
    /** linearized vertices hashes */
    verticesHashes: string[];
}
export interface GenericRespone {
    /** return error codes if different than 0 */
    returnCode: number;
}
export interface SyncDRPObjectRequest {
    drpId: string;
    peerId: string;
}
export interface SendCustomMessageRequest {
    peerId: string;
    data: Uint8Array;
}
export interface SendGroupMessageRequest {
    group: string;
    data: Uint8Array;
}
export interface AddCustomGroupRequest {
    group: string;
}
export declare const SubscribeDRPRequest: MessageFns<SubscribeDRPRequest>;
export declare const UnsubscribeDRPRequest: MessageFns<UnsubscribeDRPRequest>;
export declare const GetDRPHashGraphRequest: MessageFns<GetDRPHashGraphRequest>;
export declare const GetDRPHashGraphResponse: MessageFns<GetDRPHashGraphResponse>;
export declare const GenericRespone: MessageFns<GenericRespone>;
export declare const SyncDRPObjectRequest: MessageFns<SyncDRPObjectRequest>;
export declare const SendCustomMessageRequest: MessageFns<SendCustomMessageRequest>;
export declare const SendGroupMessageRequest: MessageFns<SendGroupMessageRequest>;
export declare const AddCustomGroupRequest: MessageFns<AddCustomGroupRequest>;
export interface DrpRpcService {
    SubscribeDRP(request: SubscribeDRPRequest): Promise<GenericRespone>;
    UnsubscribeDRP(request: UnsubscribeDRPRequest): Promise<GenericRespone>;
    GetDRPHashGraph(request: GetDRPHashGraphRequest): Promise<GetDRPHashGraphResponse>;
    SyncDRPObject(request: SyncDRPObjectRequest): Promise<GenericRespone>;
    SendCustomMessage(request: SendCustomMessageRequest): Promise<GenericRespone>;
    SendGroupMessage(request: SendGroupMessageRequest): Promise<GenericRespone>;
    AddCustomGroup(request: AddCustomGroupRequest): Promise<GenericRespone>;
}
export declare const DrpRpcServiceServiceName = "drp.node.v1.DrpRpcService";
export declare class DrpRpcServiceClientImpl implements DrpRpcService {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    SubscribeDRP(request: SubscribeDRPRequest): Promise<GenericRespone>;
    UnsubscribeDRP(request: UnsubscribeDRPRequest): Promise<GenericRespone>;
    GetDRPHashGraph(request: GetDRPHashGraphRequest): Promise<GetDRPHashGraphResponse>;
    SyncDRPObject(request: SyncDRPObjectRequest): Promise<GenericRespone>;
    SendCustomMessage(request: SendCustomMessageRequest): Promise<GenericRespone>;
    SendGroupMessage(request: SendGroupMessageRequest): Promise<GenericRespone>;
    AddCustomGroup(request: AddCustomGroupRequest): Promise<GenericRespone>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
//# sourceMappingURL=rpc_pb.d.ts.map